diff --git a/Documentation/devicetree/bindings/extcon/extcon-dra7xx.txt b/Documentation/devicetree/bindings/extcon/extcon-dra7xx.txt
new file mode 100644
index 0000000..37e4c22
--- /dev/null
+++ b/Documentation/devicetree/bindings/extcon/extcon-dra7xx.txt
@@ -0,0 +1,19 @@
+EXTCON FOR DRA7xx
+
+Required Properties:
+ - compatible : Should be "ti,dra7xx-usb"
+ - gpios : phandle to ID pin and interrupt gpio.
+
+Optional Properties:
+  - interrupt-parent : interrupt controller phandle
+  - interrupts : interrupt number
+
+
+dra7x_extcon1 {
+		compatible = "ti,dra7xx-usb";
+		gpios = <&pcf_usb 1 0>,
+			<&gpio6 11 2>;
+		interrupt-parent = <&gpio6>;
+		interrupts = <11>;
+	};
+
diff --git a/drivers/extcon/Kconfig b/drivers/extcon/Kconfig
index f1d54a3..b9cf0b2 100644
--- a/drivers/extcon/Kconfig
+++ b/drivers/extcon/Kconfig
@@ -64,4 +64,11 @@ config EXTCON_PALMAS
 	  Say Y here to enable support for USB peripheral and USB host
 	  detection by palmas usb.
 
+config EXTCON_DRA7XX
+	tristate "DRA7XX EXTCON support"
+	help
+	  Say Y here to enable support for USB peripheral and USB host
+	  detection by pcf8575 using DRA7XX extcon.
+
+
 endif # MULTISTATE_SWITCH
diff --git a/drivers/extcon/Makefile b/drivers/extcon/Makefile
index e4fa8ba..e4778f9 100644
--- a/drivers/extcon/Makefile
+++ b/drivers/extcon/Makefile
@@ -10,3 +10,4 @@ obj-$(CONFIG_EXTCON_MAX77693)	+= extcon-max77693.o
 obj-$(CONFIG_EXTCON_MAX8997)	+= extcon-max8997.o
 obj-$(CONFIG_EXTCON_ARIZONA)	+= extcon-arizona.o
 obj-$(CONFIG_EXTCON_PALMAS)	+= extcon-palmas.o
+obj-$(CONFIG_EXTCON_DRA7XX)	+= extcon-dra7xx.o
diff --git a/drivers/extcon/extcon-dra7xx.c b/drivers/extcon/extcon-dra7xx.c
new file mode 100644
index 0000000..268c25e
--- /dev/null
+++ b/drivers/extcon/extcon-dra7xx.c
@@ -0,0 +1,234 @@
+/*
+ * DRA7XX USB ID pin detection driver
+ *
+ * Copyright (C) 2013 Texas Instruments Incorporated - http://www.ti.com
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * Author: George Cherian <george.cherian@ti.com>
+ *
+ * Based on extcon-palmas.c
+ *
+ * Author: Kishon Vijay Abraham I <kishon@ti.com>
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include <linux/module.h>
+#include <linux/interrupt.h>
+#include <linux/kthread.h>
+#include <linux/freezer.h>
+#include <linux/platform_device.h>
+#include <linux/extcon.h>
+#include <linux/err.h>
+#include <linux/of.h>
+#include <linux/gpio.h>
+#include <linux/of_gpio.h>
+#include <linux/of_platform.h>
+
+struct dra7xx_usb {
+	struct device *dev;
+
+	struct extcon_dev edev;
+	struct task_struct *thread_task;
+
+	/*GPIO pin */
+	int id_gpio;
+	int irq_gpio;
+
+	int id_prev;
+	int id_current;
+
+};
+
+static const char *dra7xx_extcon_cable[] = {
+	[0] = "USB",
+	[1] = "USB-HOST",
+	NULL,
+};
+
+static const int mutually_exclusive[] = {0x3, 0x0};
+
+static int id_poll_func(void *data)
+{
+	struct dra7xx_usb *dra7xx_usb = (struct dra7xx_usb *) data;
+
+	allow_signal(SIGINT);
+	allow_signal(SIGTERM);
+	allow_signal(SIGKILL);
+	allow_signal(SIGUSR1);
+
+	set_freezable();
+
+	while (!kthread_should_stop()) {
+		dra7xx_usb->id_current = gpio_get_value_cansleep
+						(dra7xx_usb->id_gpio);
+		if (dra7xx_usb->id_current == dra7xx_usb->id_prev) {
+			schedule_timeout_interruptible
+						(msecs_to_jiffies(2*1000));
+			continue;
+		} else if (dra7xx_usb->id_current == 0) {
+			extcon_set_cable_state(&dra7xx_usb->edev, "USB", false);
+			extcon_set_cable_state(&dra7xx_usb->edev,
+						"USB-HOST", true);
+		} else {
+			extcon_set_cable_state(&dra7xx_usb->edev,
+						"USB-HOST", false);
+			extcon_set_cable_state(&dra7xx_usb->edev, "USB", true);
+		}
+		dra7xx_usb->id_prev = dra7xx_usb->id_current;
+	}
+
+	return 0;
+}
+
+static irqreturn_t id_irq_handler(int irq, void *data)
+{
+	struct dra7xx_usb *dra7xx_usb = (struct dra7xx_usb *) data;
+
+	dra7xx_usb->id_current = gpio_get_value_cansleep(dra7xx_usb->id_gpio);
+
+	if (dra7xx_usb->id_current == dra7xx_usb->id_prev) {
+		return IRQ_NONE;
+	} else if (dra7xx_usb->id_current == 0) {
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB", false);
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB-HOST", true);
+	} else {
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB-HOST", false);
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB", true);
+	}
+
+	dra7xx_usb->id_prev = dra7xx_usb->id_current;
+	return IRQ_HANDLED;
+
+}
+
+static int dra7xx_usb_probe(struct platform_device *pdev)
+{
+	struct device_node *node = pdev->dev.of_node;
+	struct dra7xx_usb *dra7xx_usb;
+	int status;
+	int irq_num;
+	int gpio;
+
+	dra7xx_usb = devm_kzalloc(&pdev->dev, sizeof(*dra7xx_usb), GFP_KERNEL);
+	if (!dra7xx_usb)
+		return -ENOMEM;
+
+
+	dra7xx_usb->dev	 = &pdev->dev;
+
+	platform_set_drvdata(pdev, dra7xx_usb);
+
+	dra7xx_usb->edev.name = dev_name(&pdev->dev);
+	dra7xx_usb->edev.supported_cable = dra7xx_extcon_cable;
+	dra7xx_usb->edev.mutually_exclusive = mutually_exclusive;
+
+	gpio = of_get_gpio(node, 0);
+	if (gpio_is_valid(gpio)) {
+		dra7xx_usb->id_gpio = gpio;
+		status = gpio_request(dra7xx_usb->id_gpio, "id_gpio");
+		if (status)
+			return status;
+	} else {
+		dev_err(&pdev->dev, "failed to get id gpio\n");
+		return -ENODEV;
+	}
+
+	gpio = of_get_gpio(node, 1);
+	if (gpio_is_valid(gpio)) {
+		dra7xx_usb->irq_gpio = gpio;
+		irq_num = gpio_to_irq(dra7xx_usb->irq_gpio);
+		if (irq_num < 0)
+			dra7xx_usb->irq_gpio = 0;
+	} else {
+		dev_err(&pdev->dev, "failed to get irq gpio\n");
+	}
+
+
+	status = extcon_dev_register(&dra7xx_usb->edev, dra7xx_usb->dev);
+	if (status) {
+		dev_err(&pdev->dev, "failed to register extcon device\n");
+		return status;
+	}
+
+	dra7xx_usb->id_prev = gpio_get_value_cansleep(dra7xx_usb->id_gpio);
+	if (dra7xx_usb->id_prev) {
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB-HOST", false);
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB", true);
+	} else {
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB", false);
+		extcon_set_cable_state(&dra7xx_usb->edev, "USB-HOST", true);
+	}
+
+	if (dra7xx_usb->irq_gpio) {
+		status = devm_request_threaded_irq(dra7xx_usb->dev, irq_num,
+				NULL, id_irq_handler, IRQF_SHARED |
+				IRQF_ONESHOT | IRQF_TRIGGER_FALLING,
+				dev_name(&pdev->dev), (void *) dra7xx_usb);
+		if (status)
+			dev_err(dra7xx_usb->dev, "failed to request irq #%d\n",
+						irq_num);
+		else
+			return 0;
+	}
+
+	dra7xx_usb->thread_task = kthread_create(id_poll_func, dra7xx_usb,
+						 dev_name(&pdev->dev));
+	if (!dra7xx_usb->thread_task) {
+		dev_err(dra7xx_usb->dev, "failed to create thread for %s\n"
+					, dev_name(&pdev->dev));
+		goto err0;
+	}
+
+	wake_up_process(dra7xx_usb->thread_task);
+
+	return 0;
+
+err0:
+	gpio_free(dra7xx_usb->id_gpio);
+	extcon_dev_unregister(&dra7xx_usb->edev);
+
+	return status;
+}
+
+static int dra7xx_usb_remove(struct platform_device *pdev)
+{
+	struct dra7xx_usb *dra7xx_usb = platform_get_drvdata(pdev);
+
+	if (!dra7xx_usb->irq_gpio)
+		kthread_stop(dra7xx_usb->thread_task);
+
+	gpio_free(dra7xx_usb->id_gpio);
+	extcon_dev_unregister(&dra7xx_usb->edev);
+
+	return 0;
+}
+
+static struct of_device_id of_dra7xx_match_tbl[] = {
+	{ .compatible = "ti,dra7xx-usb", },
+	{ /* end */ }
+};
+
+static struct platform_driver dra7xx_usb_driver = {
+	.probe = dra7xx_usb_probe,
+	.remove = dra7xx_usb_remove,
+	.driver = {
+		.name = "dra7xx-usb",
+		.of_match_table = of_dra7xx_match_tbl,
+		.owner = THIS_MODULE,
+	},
+};
+
+module_platform_driver(dra7xx_usb_driver);
+
+MODULE_ALIAS("platform:dra7xx-usb");
+MODULE_AUTHOR("George Cherian <george.cherian@ti.com>");
+MODULE_DESCRIPTION("DRA7x USB Connector driver");
+MODULE_LICENSE("GPL");
+MODULE_DEVICE_TABLE(of, of_dra7xx_match_tbl);